<?php
/**
 * User: nester_a
 * Date: 22.07.14
 */

namespace Gtm\Service;

use LMS\Libraries;
use LMS\Tools\Conference\Repositories;
use LMS\Tools\Conference\Service\Booking as BaseBookingService;

class Booking extends BaseBookingService
{
	public function __construct($options)
	{
		parent::__construct($options);
		$this->repository = $options['repository'];
	}


	/**
	 * @return array|bool
	 */
	public function synchronizeBookedConferences($oauthData)
	{
		$remoteRepository = new \Gtm\Repository\Remote\Booking(array('oauthData' => $oauthData));
		$meetings = $remoteRepository->get();

		$uniqueMeetingIDs = array();
		foreach($meetings as $meeting){
			$uniqueMeetingIDs[] = $meeting->uniqueMeetingId;
		}

		$repository = new \Gtm\Repository\Booking(array('oauthData' => $oauthData));
		$lmsRepository = new \LMS\Tools\Conference\Repositories\Booking(array());
		$gtmRepository = new \Gtm\Repository\Gtmbooking(array());

		$deletedFromGTMConferences = $repository->getDeletedFromGTMService($uniqueMeetingIDs);
		if(empty($deletedFromGTMConferences)){
			return true;
		}

		$bookedConferenceIDsToDelete = array();
		foreach($deletedFromGTMConferences as $conference){
			$bookedConferenceIDsToDelete[] = $conference->conf_id;
		}

		$isSuccessfullyDeleted = $lmsRepository->delete(array('p_id' => $bookedConferenceIDsToDelete))
								&& $gtmRepository->delete(array('conf_id' => $bookedConferenceIDsToDelete));
		return $isSuccessfullyDeleted;
	}
}