<?php
/**
 * User: nester_a
 * Date: 01.07.14
 */

namespace Gtm\Service;

use LMS\Libraries\Base;
use LMS\Tools\Conference\Repositories;

class Oauth extends Base\Service
{
	/**
	 * @var Repositories\OAuth
	 */
	private $repository;

	public function __construct($options)
	{
		parent::__construct($options);
		$this->repository = isset($options['repository']) ? $options['repository'] : new Repositories\Oauth($options);
	}

	public function checkAuthorization($userID, $isManager, $isMultiple)
	{
		if(!$isManager){
			$oauthData = $this->repository->getCommonOAuthData();
		}else{
			if(!$isMultiple){
				$oauthData = $this->repository->getCommonOAuthData();
			}else{
				$oauthData = $this->repository->getUserOAuthData($userID);
			}
		}

		$params = $this->container['registry']->get('params');
		$apikey = $this->container['registry']->get('apikey');
		if(!is_object($oauthData)){
			if($isManager){
				JLMSRedirect("https://api.citrixonline.com/oauth/authorize?client_id=".$apikey."&amp;redirect_uri=".\JURI::base()."components/com_joomla_lms/oauth.php");
			}else{
				JLMSRedirect(sefRelToAbs('index.php?option=com_joomla_lms&Itemid='.$params['ItemID'].'&id='.$params['courseID']));
			}
		}
		if((time() - strtotime($oauthData->created)) >= $oauthData->expires_in){
			JLMSRedirect("https://api.citrixonline.com/oauth/authorize?client_id=".$apikey."&amp;redirect_uri=".\JURI::base()."components/com_joomla_lms/oauth.php");
		}
	}

	public function getOAuthData()
	{
		return $this->repository->getCommonOAuthData();
	}
}