<?php
/**
 * User: nester_a
 * Date: 28.11.13
 */

namespace Jlms\Service\Response;

use LMS\Tools\Conference\Response;

/**
 * Class JlmsLMSConferenceResponseProcessor
 *
 * @method renderProfile
 * @method renderParamsXML
 * @method renderUpload
 * @method renderUploadPopUp
 * @method renderConferencePlayback
 */
class Processor extends Response\Processor
{
    public function sendHeadersForXML()
    {
        @ob_end_clean();
        header ('Expires: Fri, 14 Mar 1980 20:53:00 GMT');
        header ('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
        header ('Cache-Control: no-cache, must-revalidate');
        header ('Pragma: no-cache');
        if (class_exists('JFactory')) {
            $document = \JFactory::getDocument();
            $charset_xml = $document->getCharset();
            header ('Content-Type: text/xml; charset='.$charset_xml);
        } else {
            header ('Content-Type: text/xml');
        }
    }

    public function xmlOK($data)
    {
        $this->sendHeadersForXML();
        return parent::xmlOk($data);
    }


    /**
     * Generate XML response with 'parambook'
     * @param int $availableConference
     */
    public function generateBookingParamXMLResponse($availableConference)
    {
        $iso = explode( '=', _ISO );
        $response = '<?xml version="1.0" encoding="'.$iso[1].'" standalone="yes"?>';
        $response.= '<response>' . "\n";
        $response.= '<parambook>'.$availableConference.'</parambook>';
        $response.=  '</response>' . "\n";

        return $response;
    }

    public function generateParamsXMLResponse($config, $params, $iso, $pseudo, $acl, $files)
    {
        $this->setRenderParams(array(
            'iso' => $iso,
            'jlmsVersion' => $config->get('jlms_version'),
            'flashComRoot' => $params->get('flascommRoot'),
            'pseudo' => $pseudo,
            'maxClients' => $params->get('maxConfClients'),
            'liveSite' => $config->get('live_site'),
            'webRoot' => $config->get('live_site'),
            'manage' => $acl->CheckPermissions('conference', 'manage') ? "yes" : "no",
            'language' => $config->get('default_language'),
            'conferenceBackground' => $params->get('conf_background'),
            'conferenceMainColor' => $params->get('conf_main_color'),
            'conferenceBorderColor' => $params->get('conf_border_color'),
            'conferenceTitleColor' => $params->get('conf_title_color'),
            'conferenceTitleFontColor' => $params->get('conf_title_font_color'),
            'conferenceToolbarColor' => $params->get('conf_toolbar_color'),
            'conferenceFilesFontColor' => $params->get('conf_files_font_color'),
            'files' => $files
        ));
        return $this->renderParamsXML()->getContent();
    }
}