<?php
defined('_JEXEC') or die;

use LMS\Libraries\ServiceLocator;

class AnnouncementHelperOutput
{
    public static function RenderAnnouncements($announcements)
    {
        $date_handler = \LMS\Libraries\ServiceLocator::get('date_handler');
        foreach ($announcements as $announcement) {
            $item_link = JLMSRoute::_('index.php?option=com_joomla_lms&task=announcements.announcement&id='.(int)$announcement->agenda_id.'&course_id='.$announcement->course_id);
            ?>
            <div class="media <?php if ($announcement->featured) echo ' announ_featured ';?>">
                <div class="media-left">
                    <time datetime="<?php echo $announcement->start_date;?>" class="lms-announcement-icon">
                        <em><?php echo date('l', strtotime($announcement->start_date));?></em>
                        <strong><?php echo date('F', strtotime($announcement->start_date));?></strong>
                        <span><?php echo date('d', strtotime($announcement->start_date));?></span>
                    </time>
                </div>
                <div class="media-body">
                    <h2 class="media-heading">
                        <a  class="hasTooltip" title="<?php echo JHtml::tooltipText(($announcement->content)?($announcement->content):$announcement->title);?>" href="<?php echo $item_link; ?>">
                            <?php echo $announcement->title;?>
                        </a>
                    </h2>
                    <div> <span class="icon-enter"></span><strong><?php echo JText::_('_JLMS_ANNOUNCEMENTS_START_DATE');?></strong>: <?php echo $announcement->start_date;?></div>
                    <div> <span class="icon-exit"></span> <strong><?php echo JText::_('_JLMS_ANNOUNCEMENTS_END_DATE');?></strong>: <?php echo $announcement->end_date;?></div>
                   <div> <span class="jlmsicon-courses"></span> <strong><?php echo JText::_('_JLMS_COURSE');?></strong>: <?php echo $announcement->course_name;?></div>
                </div>
            </div>
        <?php
        }
    }

	public static function showTopFilters( $course_id = 0, $announcement_filter = 'all', $items_count_array = array() )
	{
        $first_part_link = 'index.php?option=com_joomla_lms&task=announcements.announcements.set_filter&course_id='.$course_id.'&announcement_filter=';
        ?>
        <div class="jlms_announcement_status_filters">
            <div class="btn-group">
               <a href="<?php echo JRoute::_($first_part_link.'all'); ?>" class="btn <?php echo ($announcement_filter=='all'?'active':'');?>"><span class="icon-grid-2"></span> <?php echo JText::_('_JLMS_ANNOUNCEMENTS_FILTER_ALL');?> [<?php echo $items_count_array['all'];?>]</a>
               <a href="<?php echo JRoute::_($first_part_link.'started'); ?>" class="btn <?php echo ($announcement_filter=='started'?'active':'');?>"><span class="icon-clock"></span> <?php echo JText::_('_JLMS_ANNOUNCEMENTS_FILTER_STARTED');?> [<?php echo $items_count_array['started'];?>]</a>
               <a href="<?php echo JRoute::_($first_part_link.'upcoming'); ?>" class="btn <?php echo ($announcement_filter=='upcoming'?'active':'');?>"><span class="icon-arrow-right-4"></span> <?php echo JText::_('_JLMS_ANNOUNCEMENTS_FILTER_UPCOMING');?> [<?php echo $items_count_array['upcoming'];?>]</a>
               <a href="<?php echo JRoute::_($first_part_link.'finished'); ?>" class="btn <?php echo ($announcement_filter=='finished'?'active':'');?>"><span class="icon-flag"></span> <?php echo JText::_('_JLMS_ANNOUNCEMENTS_FILTER_FINISHED');?> [<?php echo $items_count_array['finished'];?>]</a>
            </div>
        </div>
        <br />
        <?php
	}

    public static function getDateCompareTextAndParams($interval, $type)
    {
        $started = $upcoming = $finished = false;
        $time_string = '';
        if ($interval->years) $time_string .=  $interval->years.JText::_('_JLMS_ANNOUNCEMENTS_YEARS');
        if ($interval->months) $time_string .= $interval->months.JText::_('_JLMS_ANNOUNCEMENTS_MONTHS');
        if ($interval->days) $time_string .= $interval->days.JText::_('_JLMS_ANNOUNCEMENTS_DAYS');
        if ($interval->hours) $time_string .= $interval->hours.JText::_('_JLMS_ANNOUNCEMENTS_HOURS');
        if ($interval->minutes) $time_string .= $interval->minutes.JText::_('_JLMS_ANNOUNCEMENTS_MINUTES');

        if ($interval->type == 'more')
        {
            $upcoming = ($type=='start'?true:false);
            $pre_text = ($type=='start'?JText::_('_JLMS_ANNOUNCEMENTS_START_AFTER'):JText::_('_JLMS_ANNOUNCEMENTS_FINISH_AFTER'));
            $time_string = $pre_text.$time_string;
        } else
        {
            $started = ($type=='start'?true:false);
            $finished = ($type=='finish'?true:false);
            $pre_text = ($type=='start'?JText::_('_JLMS_ANNOUNCEMENTS_STARTED'):JText::_('_JLMS_ANNOUNCEMENTS_FINISHED'));
            $time_string = $pre_text.$time_string;
        }
        $result = array('time_string'=>$time_string, 'started'=>$started, 'upcoming'=>$upcoming, 'finished'=>$finished);
        return $result;
    }

    public static function getStatusItemParams($started, $upcoming, $finished)
    {
        if ($started && !$finished) {
            $params['title'] = JText::_('_JLMS_ANNOUNCEMENTS_FILTER_STARTED');
            $params['icon'] = 'clock';
        }

        if ($finished) {
            $params['title'] = JText::_('_JLMS_ANNOUNCEMENTS_FILTER_FINISHED');
            $params['icon'] = 'flag';
        }

        if ($upcoming && !$finished) {
            $params['title'] = JText::_('_JLMS_ANNOUNCEMENTS_FILTER_UPCOMING');
            $params['icon'] = 'arrow-right-4';
        }

        $params['type'] = 'custom';
        //$params['active'] = true;
        return $params;
    }

    public static function getReleasedTimeText($parsed_periods)
    {
        $released_info_txt = _JLMS_WILL_BE_RELEASED_IN;
        $released_info_time = false;
        if ($parsed_periods['days']) {
            $released_info_txt .= ' '.$parsed_periods['days'].' '._JLMS_RELEASED_IN_DAYS;
            $released_info_time = true;
        }
        if ($parsed_periods['hours']) {
            $released_info_txt .= ' '.$parsed_periods['hours'].' '._JLMS_RELEASED_IN_HOURS;
            $released_info_time = true;
        }
        if ($parsed_periods['minutes']) {
            $released_info_txt .= ' '.$parsed_periods['minutes'].' '._JLMS_RELEASED_IN_MINUTES;
            $released_info_time = true;
        }
        if ($released_info_time) {
            $released_info_txt .= ' '._JLMS_RELEASED_AFTER_ENROLLMENT;
        }
        return '<span class="icon-unlock"></span><span>'.$released_info_txt.'</span>';
    }

    public static function getPublishUnpublishStartEndDateText($announcement, $info_button_content='' )
    {
        if ($announcement->start_publish_date!='0000-00-00 00:00:00' || $announcement->end_publish_date!='0000-00-00 00:00:00')
        {
            if ($info_button_content) $info_button_content.='<br />';
            if ($announcement->start_publish_date)
            {
                $info_button_content .= '<span class="icon-enter"></span><span>'.JText::_('_JLMS_ANNOUNCEMENTS_START_PUBLISH_DATE').$announcement->start_publish_date.'</span>';
            }
            if ($info_button_content) $info_button_content.='<br />';
            if ($announcement->end_publish_date)
            {
                $info_button_content .= '<span class="icon-exit"></span><span>'.JText::_('_JLMS_ANNOUNCEMENTS_END_PUBLISH_DATE').$announcement->end_publish_date.'</span>';
            }
        }
        return $info_button_content;
    }

    public static function showStartEndDatesInfo($announcement, $start_time_string, $finish_time_string)
    {
    ?>     <div class="jlms_announcement_smalltxt">
                <span class="icon-enter"></span><span><?php echo JText::_('_JLMS_ANNOUNCEMENTS_START_DATE');?>: <?php echo $announcement->start_date;?></span>
                <span class="icon-exit"></span><span><?php echo JText::_('_JLMS_ANNOUNCEMENTS_END_DATE');?>: <?php echo $announcement->end_date;?></span>
            </div>
            <div class="jlms_announcement_smalltxt">
                <span class="icon-clock"></span>
                <?php echo $start_time_string.'<br />'; ?>
                <span class="icon-flag"></span>
                <?php echo $finish_time_string;  ?>
            </div>
    <?php
    }

    public static function showLocationInfo($location='')
    {
        ?>
        <div class="jlms_announcement_smalltxt">
            <img width="16" height="16" border="0" title="" alt="" class="" src="components/com_joomla_lms/lms_images/agenda/map_location.png" />
            <?php echo $location;?>
        </div>
      <?php
    }

    public static function showCalendarHtmlBlock()
    {
        ?>
        <div style="display: block">
            <div id="scheduler_here" class="dhx_cal_container"  style='width:auto; height:500px; padding:10px;'>
                <div class="dhx_cal_navline">
                    <div class="dhx_cal_prev_button">&nbsp;</div>
                    <div class="dhx_cal_next_button">&nbsp;</div>
                    <div class="dhx_cal_today_button"></div>
                    <div class="dhx_cal_date"></div>
                    <div class="dhx_cal_tab" name="day_tab" style="right:204px;"></div>
                    <div class="dhx_cal_tab" name="week_tab" style="right:140px;"></div>
                    <!--<div class="dhx_cal_tab" name="map_tab" style="right:280px;"></div>-->
                    <div class="dhx_cal_tab" name="month_tab" style="right:76px;"></div>
                </div>
                <div class="dhx_cal_header"></div>
                <div class="dhx_cal_data"></div>
            </div>
        </div>
        <?php
    }

    public static function showCalendarScript($course_id=0, $acl=null)
    {
        ?>
        <script>
        <?php if (!$acl->CheckPermissions('announce', 'manage') ){ ?>
            //scheduler.config.readonly = true;
            scheduler.config.dblclick_create = false;
            scheduler.config.drag_move = false;
            scheduler.config.drag_resize = false;

            //block all modifications
            scheduler.attachEvent("onBeforeDrag",function(){return false;})
            scheduler.attachEvent("onClick",function(){return false;})
            scheduler.config.details_on_dblclick = true;
            scheduler.config.readonly_form = true;
            <?php
        }
       // else
        {
        ?>

        scheduler.config.drag_create = false;
        scheduler.config.dblclick_create = false;

        scheduler.attachEvent("onDblClick", function(id){
            location.href ='<?php echo \Juri::root();?>index.php?option=com_joomla_lms&task=announcements.announcement&id='+id+'&course_id=<?php echo $course_id;?>&Itemid=<?php echo JLMSSystemMenu::getItemIdByTool('details_course',$course_id);?>';
            return false;
        });

        scheduler.config.lightbox.sections=[
            {name:"description", height:43, map_to:"text", type:"textarea" , focus:true},
            {name:"time", height:72, type:"time", map_to:"auto" }
        ];
        scheduler.config.xml_date="%Y-%m-%d %H:%i";

        <?php
       }
       ?>
        scheduler.init('scheduler_here', new Date(),"month");
        scheduler.load("<?php echo \JLMSRoute::_('index.php?option=com_joomla_lms&task=announcement_calendar&course_id='.$course_id)?>");
        var dp = new dataProcessor("<?php echo \JLMSRoute::_('index.php?option=com_joomla_lms&task=announcement_calendar');?>");
        dp.init(scheduler);

    </script>
        <?php
    }
}
