<?php
namespace LMS\Tools\Announcements\Model;

use LMS\Libraries\Base;
use LMS\Libraries;
use LMS\Libraries\ServiceLocator;
use LMS\Libraries\Repository;
use LMS\Libraries\User;
use LMS\Tools\Announcements\Repositories;

defined('_JEXEC') or die;


class Announcement extends Base\Model
{
    protected $name='Announcement';

    public function __construct($options)
    {
        $this->modelDir = __DIR__;
        parent::__construct($options);
        $this->repository = isset($options['repository']) ? $options['repository'] : new Repositories\Announcements(array('db' => ServiceLocator::get('db')));
    }

    public function getItem($id = null)
    {
        $item = null;
        $id = $this->getState('announcement.id', 0);
        $item = $this->repository->getByID($id);
        return $item;
    }

    public function deleteItem($id = null)
    {
        $conditions = array('agenda_id'=>$id);
        $result = $this->repository->delete($conditions);
        return $result;
    }

    public function save($data=array())
    {
        $isnew = true;
        if (isset($data['id']))
            if ($data['id']>0)
            {
                $isnew = false;
            }

        $data['show_period'] = 0;
        if( $data['is_time_related'] ) {

            $days = (int)$data['days'];
            $hours = (int)$data['hours'];
            $minutes = (int)$data['minutes'];
            $show_period = $days*24*60+$hours*60+$minutes;
            $data['show_period'] = $show_period;
        }

        if ($isnew)
        {
            $this->repository->save($data);
        }else
        {
            $this->repository->update($data, array('agenda_id'=>(int)$data['id']));
            return $data['id'];
        }
        return $this->repository->getId();
    }

    public function getForm($name = 'Announcement', $params = array())
    {
        $loadParams = array_merge(array('control' => 'jform', 'load_data' => true), $params);

        return  $this->loadForm('com_joomla_lms.'.$name, $name, $loadParams);
    }

    public function loadFormData()
    {
        return $this->getItem();
    }

}