<?php
namespace LMS\Tools\Courses\Helpers;

defined('_JEXEC') or die;

use LMS\Libraries\ServiceLocator;

$config = ServiceLocator::get('config');
$tmpFolder = $config->get('temp_folder', 'jlms');

defined('JLMS_LOGO_BASE_DIR') or define('JLMS_LOGO_BASE_DIR', JPATH_ROOT.DS.$tmpFolder.DS.'courseslogo'.DS);
defined('JLMS_LOGO_BASE_URL') or define('JLMS_LOGO_BASE_URL',  \JURI::root() . $tmpFolder.'/courseslogo/');
defined('JLMS_LOGO_BASE_URL_REL') or define('JLMS_LOGO_BASE_URL_REL',  $tmpFolder.'/courseslogo/');

class Logo
{	
	public static $baseDir = JLMS_LOGO_BASE_DIR;
	
	public static $baseUrl = JLMS_LOGO_BASE_URL;
	
	public static $baseUrlRel = JLMS_LOGO_BASE_URL_REL;
	
	public static $types = array('small', 'medium', 'large');
	
	public static function sizes()
	{
		$sizes = array();

		$size = new \stdClass();
		$size->width = 96;
		$size->height = 96;
		$sizes['small'] = $size;

		$size = new \stdClass();
		$size->width = 128;
		$size->height = 128;
		$sizes['medium'] = $size;

		$size = new \stdClass();
		$size->width = 256;
		$size->height = 256;
		$sizes['large'] = $size;
		
		return $sizes;			
	}

	public static function fileUrl($filename, $type)
	{		
		if(in_array($type, static::$types))
		{
			return $res = static::$baseUrl.$type.'_'.$filename;
		}		
		
		return false;
	}
	
	public static function fileUrlRel($filename, $type)
	{		
		if(in_array($type, static::$types))
		{
			return $res = static::$baseUrlRel.$type.'_'.$filename;
		}		
		
		return false;
	}
	
	public static function filePath($filename, $type)
	{	
		if(in_array($type, static::$types))
		{
			\JFolder::create(static::$baseDir);
			return static::$baseDir.$type.'_'.$filename;
		}

		return false;
	}
	
	public static function clean($filename)
	{	
		foreach(static::$types AS $type)
		{			
			\JFile::delete(static::filePath($filename, $type));
		}		
	}
	
	public static function getLogo($logoParam, $type = 'small')
	{
		$logo = "";
		$sizes = static::sizes();
		$samplelogos = array();
		$samplelogos[] = 'joomlalms_sample_courselogo1.png';
		$samplelogos[] = 'joomlalms_sample_courselogo2.png';
		$samplelogos[] = 'joomlalms_sample_courselogo3.png';
		$samplelogos[] = 'joomlalms_sample_courselogo4.png';
		$samplelogos[] = 'joomlalms_sample_courselogo5.png';
		$samplelogos[] = 'joomlalms_sample_courselogo6.png';
		//TODO: add additional checks for samplelogos
		if ($logoParam && in_array($logoParam, $samplelogos)) {
			$logo = "<span class=\"jlmsicon-".str_replace('.png','',$logoParam)." jlms-icon-logo-".$type."\"></span>";
		} elseif ($logoParam) {
			$logo_path = static::fileUrl($logoParam, $type);
			$logo = "<img class=\"joomlalms-courselogo-image\" src=\"".$logo_path."\" width=\"".(isset($sizes[$type]->width)?$sizes[$type]->width:'96')."\" height=\"".(isset($sizes[$type]->height)?$sizes[$type]->height:'96')."\" />";
		} else {
			$logo = "<span class=\"jlmsicon-course jlms-icon-logo-".$type."\"></span>";
		}
		return $logo;
	}
}
