<?php
namespace LMS\Tools\Homework\Tables;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

defined('_JEXEC') or die;

class HomeworkResults extends Base\Table
{
	protected $fieldMap = array(
		'id' => 'id',
		'course_id' => 'course_id',
		'user_id' => 'user_id',
		'hw_id' => 'hw_id',
		'hw_status' => 'hw_status',
		'write_text' => 'write_text',
		'file_id' => 'file_id',
		'grade' => 'grade',
		'comments' => 'comments',
	);

	protected $alias = 'hwr';

	public function __construct()
	{
		parent::__construct('#__lms_homework_results', 'id');
	}

	protected function initRelations()
	{
		parent::initRelations(); // TODO: Change the autogenerated stub

		$this->relations['homework'] = array(
			'table' => new Homework(),
			'type' => 'INNER',
			'condition' => '{parent.hw_id} = {child.id}',
			'capacity' => self::ONE
		);

		$this->relations['profile'] = array(
			'table' => ServiceLocator::get('joomlaUsersTable'),
			'type' => 'INNER',
			'condition' => '{parent.user_id} = {child.id}',
			'capacity' => self::ONE
		);

		$this->relations['gradebook_scale'] = array(
			'table' => new \LMS\Libraries\Repository\Tables\Gradebook_Scale(),
			'type' => 'INNER',
			'condition' => '{parent.course_id} = {child.course_id}',
			'capacity' => self::MANY
		);

		$this->relations['file'] = array(
			'table' => new \LMS\Libraries\Repository\Tables\Files($this->_db),
			'type' => 'INNER',
			'condition' => '{parent.file_id} = {child.id}',
			'capacity' => self::ONE
		);
	}
}